<?php
/*
Plugin Name: meta
Version: 2.0.0.a
Description: Allows to add metadata
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=220
Author: ddtddt
Author URI: http://piwigo.org/
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $prefixeTable;

define('meta_DIR' , basename(dirname(__FILE__)));
define('meta_PATH' , PHPWG_PLUGINS_PATH . meta_DIR . '/');
define('meta_TABLE' , $prefixeTable . 'meta');

add_event_handler('get_admin_plugin_menu_links', 'meta_admin_menu');
function meta_admin_menu($menu)
{
  array_push($menu, array(
		'NAME' => 'Meta',
    'URL' => get_admin_plugin_menu_link(meta_PATH . 'admin/admin.php')));
  return $menu;
}

//Gestion des meta dans le header
add_event_handler('loc_begin_page_header', 'add_meta' );
function add_meta()
{
  global $template, $page, $meta_infos;

  $meta_infos = array();
  $meta_infos['author'] = $template->get_template_vars('INFO_AUTHOR');
  $meta_infos['related_tags'] = $template->get_template_vars('related_tags');
  $meta_infos['info'] = $template->get_template_vars('INFO_FILE');

  // Author
  $query = '
  select id,metaname,metaval
    FROM ' . meta_TABLE . '
    WHERE metaname = \'author\'
    ;';
  $result = pwg_query($query);
  $row = mysql_fetch_array($result);
  if (!empty($meta_infos['author']) and !empty($row['metaval']))
  {
    $template->assign('INFO_AUTHOR', $meta_infos['author'] . ' - ' . $row['metaval']);
  }
  elseif (!empty($row['metaval']))
  {
    $template->assign('INFO_AUTHOR', $row['metaval']);
  }
  
  // Keywords
  $query = '
  select id,metaname,metaval
    FROM ' . meta_TABLE . '
    WHERE metaname = \'keywords\'
    ;';
  $result = pwg_query($query);
  $row = mysql_fetch_array($result);
  $template->append('related_tags', array('name' => $row['metaval']));

  // Description
  $query = '
  select id,metaname,metaval
    FROM ' . meta_TABLE . '
    WHERE metaname = \'Description\'
    ;';
  $result = pwg_query($query);
  $row = mysql_fetch_array($result);
  if (!empty($meta_infos['info']) and !empty($row['metaval']))
  {
    $template->assign('INFO_FILE', $meta_infos['info'] . ', ' . $row['metaval']);
  }
  elseif (!empty($row['metaval']))
  {
    $template->assign('INFO_FILE', $row['metaval']);
  }

  // Robots
  $query = '
  select id,metaname,metaval
    FROM ' . meta_TABLE . '
    WHERE metaname = \'robots\'
    ;';
  $result = pwg_query($query);
  $row = mysql_fetch_array($result);
  if (!empty($row['metaval']))
  {
    $template->append('head_elements', 
      '<meta name="robots" content="'.$row['metaval'].'">'
    );
  }

  //meta categories
  if ( !empty($page['category']['name']) )   
  {
    $page['category']['info'] = get_cat_info($page['category']['id']);
    $page['category']['name'] = $page['category']['info']['name'];

    $query = '
    select id,name,metakeywords,comment
      FROM ' . CATEGORIES_TABLE . '
      WHERE id = \''.$page['category']['id'].'\'
      ;';
    $result = pwg_query($query);
    $row = mysql_fetch_array($result);
    if (!empty($row['metakeywords']))
    {
      $template->append('related_tags', array('name' => $row['metakeywords']));
    }
  }
}


add_event_handler('loc_after_page_header', 'set_meta_back');
function set_meta_back()
{
  global $template, $meta_infos;
  
  $template->assign('INFO_AUTHOR', $meta_infos['author']);
  $template->assign('related_tags', $meta_infos['related_tags']);
  $template->assign('INFO_FILE', $meta_infos['info']);
}
?>